

#include "SingleFolderHandler.h"
#include "txtGeneration.h"
#include "FileUtil.h"



void setPrivFolderAsEmptyAmount(const std::string& folder, const int addressNum, const std::string& thetime)
{
	const std::string privEmptyFile = SingleFolderHandler::getSinglePrivEmptyFile(folder, addressNum);

	std::cout << "Writing file: " << privEmptyFile << std::endl;
	const std::string contents = createEmptyFileContent(addressNum, thetime);
	fileWrite(privEmptyFile, contents);
}


std::string SingleFolderHandler::getTotalPubFolder(const std::string& pubFolder, const int addressNum)
{
	const std::string baseFolder = (pubFolder + "/cold/pub");		
	const std::string totFolder = (baseFolder + "/" + getCurrencyShortName() + "/");
	
	const std::string theFolder	= totFolder + "pub_" + getCurrencyShortName() + "_" + intToString(addressNum) + "/";

	return theFolder;
}



std::string SingleFolderHandler::getSinglePrivEmptyFile(const std::string& privFolder, const int addressNum)
{
	const std::string theFolder	= getSingleTotalPrivFolder(privFolder, addressNum);

	if(!directoryExist(theFolder))
	{
		std::cout << "Folder does not exist: " << theFolder << std::endl;
		return "";
	}

	const std::string theFile = theFolder + "/empty_" + getCurrencyShortName() + "_address_" + intToString(addressNum) + "_pad.txt";		//EMPTYNAME

	return theFile;
}


std::string SingleFolderHandler::getSinglePubEmptyFile(const std::string& pubFolder, const int addressNum)
{
	const std::string theFolder	= getTotalPubFolder(pubFolder, addressNum);

	if(!directoryExist(theFolder))
	{
		std::cout << "Public folder does not exist: " << theFolder << std::endl;
		throw std::string("Public folder does not exist");
	}

	const std::string theFile = theFolder + "empty_" + getCurrencyShortName() + "_address_" + intToString(addressNum) + "_pad.txt";		//EMPTYNAME

	return theFile;
}



std::string SingleFolderHandler::getSingleTotalPrivFolder(const std::string& pubFolder, const int addressNum)
{
	const std::string baseFolder = (pubFolder + "/cold/priv");		
	const std::string totFolder = (baseFolder + "/" + getCurrencyShortName() + "/");
	
	const std::string theFolder	= totFolder + "priv_" + getCurrencyShortName() + "_" + intToString(addressNum);

	return theFolder;
}




