#ifndef TRANSACTION_COMMANDLINE_H
#define TRANSACTION_COMMANDLINE_H


#include "binaryTransaction.h"
#include "BinaryScript.h"
#include "RSVal.h"
#include "pubKey.h"
#include "CliArguments.h"

#include <vector>
#include <string>


void createMultisig(const CliArguments& args);
void partSignMultisig(const CliArguments& args);
void combineMultisigSignatures(const CliArguments& args);


class TransactionCommandline
{
public:
	static void getTransactionInputHashes(const CliArguments& args);
	static void saveScript(const CliArguments& args);
	static void decodeScript(const CliArguments& args);
	static void decodeTransaction(const CliArguments& args);

	static void saveTheTransaction(const CliArguments& args);
	static void parseTransaction(const CliArguments& args);
	static void runTrans(const CliArguments& args);
	static void createTransaction(const CliArguments& args);

	static BinaryTransaction getTrans(const std::string& arg);
	static RSVal getSigFromFile(const std::string& filename);
	static bool transactionSupportedForCurrency();

	static PubKey stringToPubkey(const std::string pkifStr);
	static BinaryScript createOpreturnScript(const std::string& dataStr, const std::string& typeStr);

private:

	static BinaryScript getScript(const std::string& arg);
	
};


	



#endif

