#ifndef DIRECTORY_HEADER
#define DIRECTORY_HEADER


#include <set>
#include <string>


class DirEntry
{
public:
		DirEntry(std::string inName, bool inIsDir) : name(inName), isDir(inIsDir) {}
	
	std::string name;
	bool isDir;
};


bool operator<(const DirEntry& a, const DirEntry& b);


class Directory
{
public:
	Directory();
	Directory(const std::string& folderName);
	
	const std::set<std::string> getEntries() const;
	const std::set<std::string> getFolders() const;

	bool hasItem(const std::string& item) const;
	
private:
	void openDir(const std::string& folderName);

	std::set<DirEntry> entries;
};




#endif
