#pragma once

#include "GenerationParameters.h"

#include <vector>
#include <string>


class CliArguments
{
public:	
	static CliArguments argcvToCliArgument(const int argc, char* argv[]);	


	CliArguments startAt(const int paramStartPos) const
	{
		CliArguments ret(args, startPos + paramStartPos);
		return ret;
	}


	std::string toString() const;
	std::string prefixString() const;
	
	std::string operator[](const int i) const;
	int size() const { return args.size() - startPos; }
	
	
	GenerationParameters parseTheExtraParams(const int startPos, const bool useCurrencySpecific = false) const;

	std::list<BigInt<256> > getPadsFromArgs(bool& useStaticXorIfPresent, GenerationParameters& params, int& addressNum, std::string& genTime) const;
	std::list<BigInt<256> > getPadsFromCommandline(bool& useStaticXorIfPresent) const;

	
	
	

private:
	explicit CliArguments(const std::vector<std::string>& inArgs, const int startAt = 0);

	int indexPos(const int i) const
	{
		return i + startPos;
	}

	std::vector<std::string> getExtraArgs(const int start) const;

	const int startPos = 0;

	std::vector<std::string> args;
};



