
#include "CommandlineParser.h"

#include "commandLine.h"
#include "ExtraOptionsRandom.h"

#include <iostream>

#include "CliArguments.h"



GenerationParameters parseTheExtraParams(const CliArguments& args, const int startPos, 
	const bool useCurrencySpecific)
{
	GenerationParameters params;	

	const CliArguments allExtraArgs = args.startAt(startPos);

	ExtraOptionsRandom extraOptions;
	
		
	for(int i = 0 ; i < allExtraArgs.size() ; i++)
	{
		const std::string& arg = allExtraArgs[i];
		
		if(params.useArg(arg))
		{
			//Nothing
		}
		else if(extraOptions.useArg(arg))
		{
			//Nothing			
		}
		else if(useCurrencySpecific && params.useCurrencySpecific(arg))
		{
			//Nothing			
		}		
		else
		{
			std::cout << "Incorrect argument: " << arg << std::endl;
			throw std::string("Argument error");			
		}
	}
	
	params.checkNameProvided();
	return params;
}


