


#include <iostream>
#include <string>


#include "util.h"

#include "mnemonic.h"
#include "ExtendedAddressCommandline.h"




void testFirstReceiveAddress(const std::string& mnemonic, const std::string& pubAddr)
{
	std::cout << "Testing " << pubAddr << " ..." << std::flush;
	const Mnemonic mnemonicObj(mnemonic);
	std::string path;
	const PrivKey privKey = mnemonicToFirstPrivateKey(mnemonicObj, path);
	const BitcoinEllipticCurve ec;
	const PubAddress pubAddress = privKey.getAddress(ec);
	
	if(pubAddress.toFullCashAddrString() != pubAddr)
	{
		std::cout << "Error, " << pubAddress.toFullCashAddrString() << " != " << pubAddr << std::endl;
		throw std::string("Error in testFirstReceiveAddress");
	}

	std::cout << "OK" << std::endl;
}



void unitTestsBitcoinCashSLP()
{		
	testFirstReceiveAddress("tonight mushroom various sauce orphan today hair please broccoli report forum room sure saddle hover admit anchor alley hip mail spring scissors okay question", 
		"simpleledger:qzymae36cw5n6us6jzxky23fx4lj6pxevysxew43wn");
		
	testFirstReceiveAddress("pizza alcohol utility current manual purity alone crazy powder make van will outside elephant gloom staff soda vast decorate stone orchard involve host employ",
		"simpleledger:qr7th6277sarkhn82nw3zv0w27fcf33ffssvmv7ph6");
}


void unitTestsBitcoinCashToken()
{	
	std::cout << "Will test cash token" << std::endl;
	
	testFirstReceiveAddress("tonight mushroom various sauce orphan today hair please broccoli report forum room sure saddle hover admit anchor alley hip mail spring scissors okay question", 
		"bitcoincash:zquk0ctpkwjuu23mj43cpxgrhhvgv9g4ysx7gf022h");
		
	testFirstReceiveAddress("pizza alcohol utility current manual purity alone crazy powder make van will outside elephant gloom staff soda vast decorate stone orchard involve host employ",
		"bitcoincash:zr42cl920zvs66e79azmj2596fsc67cdtskqqu40lu");
}



void testMyFirstReceiveAddress(const std::string& mnemonic, const std::string& pubAddr)
{
	std::cout << "Testing " << pubAddr << " ..." << std::flush;
	const Mnemonic mnemonicObj(mnemonic);
	std::string path;
	const PrivKey privKey = mnemonicToFirstPrivateKey(mnemonicObj, path);
	const BitcoinEllipticCurve ec;
	const PubAddress pubAddress = privKey.getAddress(ec);
	
	if(pubAddress.toFullCashAddrString() != pubAddr)
	{
		std::cout << "Error, " << pubAddress.toFullCashAddrString() << " != " << pubAddr << std::endl;
		throw std::string("Error in testFirstReceiveAddress");
	}

	std::cout << "OK" << std::endl;
}



void extraunitTestsBitcoinCashSLP()
{		
	testMyFirstReceiveAddress("tonight mushroom various sauce orphan today hair please broccoli report forum room sure saddle hover admit anchor alley hip mail spring scissors okay question", 
		"simpleledger:qzymae36cw5n6us6jzxky23fx4lj6pxevysxew43wn");
		
	testMyFirstReceiveAddress("pizza alcohol utility current manual purity alone crazy powder make van will outside elephant gloom staff soda vast decorate stone orchard involve host employ",
		"simpleledger:qr7th6277sarkhn82nw3zv0w27fcf33ffssvmv7ph6");


	testFirstReceiveAddress("pizza alcohol utility current manual purity alone crazy powder make van will outside elephant gloom staff soda vast decorate stone orchard involve host employ",
		"bitcoincash:qr42cl920zvs66e79azmj2596fsc67cdts32nzmfq0");
	
	testFirstReceiveAddress("surround child talent wonder safe number fun main screen blade alter tired member cross denial glory old august forest cheap dawn video oak tackle",
		"bitcoincash:qrxa50fpxx4v8hll80ug9p7wmw62xhm96g29s929f0");
		
	testFirstReceiveAddress("switch visa muffin aerobic cool potato market pioneer sunset clinic code poverty offer cook beef material sad excess pause gaze same heart midnight ignore",
		"bitcoincash:qz45aq3687njj5tx5ffx2k9qdheh5gw5pqh9xnuclt");

}







