
#include "mnemonic.h"

#include "miniPriv.h"



void testMiniPriv()
{
	std::cout << "Will test mini private key" << std::endl;	
	

	
	const BitcoinKeyPair minikeypair = convertMiniPriv("S6c56bnXQiBjk9mqSYE7ykVQ7NzrRy", false);
	if(minikeypair.pubaddr.toStringLegacy() != "1CciesT23BNionJeXrbxmjc7ywfiyM4oLW")
	{
		std::cout << "Address: " << minikeypair.pubaddr.toStringLegacy() << std::endl;
		throw std::string("Mini private test failed");			
	}
		
		
	//std::cout << "------------Will check mini private key result" << std::endl;	
		
	if(minikeypair.privaddr.toString() != "5JPy8Zg7z4P7RSLsiqcqyeAF1935zjNUdMxcDeVrtU1oarrgnB7")
	{
		std::cout << "Privkey: " << minikeypair.privaddr.toString() << std::endl;			
		throw std::string("Mini priv test failed");						
	}
		
	std::cout << "Testing mnemonics" << std::endl;

		
	const BigInt<256> firstTestVector(BigInt<256>::fromHex("39489384938478162378126313123123123222178236183617826772727727f2"));
	//const std::string testMnemonic = generateMnemonic(firstTestVector);
	const Mnemonic myMnemonicObj(firstTestVector); // = Mnemonic::generate(firstTestVector);
	const std::string testMnemonic = myMnemonicObj.toStr();
	
	
	std::cout << "The test mnemonic: " << testMnemonic << std::endl;
		
	const Mnemonic mnemonicObj2(testMnemonic);	
	const BigInt<256> secondTestVector = mnemonicObj2.toPrivKey();
		
	if(firstTestVector != secondTestVector)
	{	
		std::cout << "First test vector : " << firstTestVector << std::endl;
		std::cout << "Second test vector: " << secondTestVector << std::endl;
		
		throw std::string("Mnemonic test 1 failed");
	}
}



void testMiniPriv2()
{				
	std::cout << "Will test mini private key" << std::endl;	
		
		
	const BitcoinKeyPair minikeypair = convertMiniPriv("S6c56bnXQiBjk9mqSYE7ykVQ7NzrRy", false);
	if(minikeypair.pubaddr.toString() != "1CciesT23BNionJeXrbxmjc7ywfiyM4oLW")
	{
		std::cout << "Address: " << minikeypair.pubaddr.toString() << std::endl;
		throw std::string("Mini priv test failed");			
	}
		
		
	//std::cout << "------------Will check mini private key result" << std::endl;	
		
	if(minikeypair.privaddr.toString() != "5JPy8Zg7z4P7RSLsiqcqyeAF1935zjNUdMxcDeVrtU1oarrgnB7")
	{
		std::cout << "Privkey: " << minikeypair.privaddr.toString() << std::endl;			
		throw std::string("Mini priv test failed");						
	}
		
	std::cout << "Testing mnemonics" << std::endl;

		
	const BigInt<256> firstTestVector(BigInt<256>::fromHex("39489384938478162378126313123123123222178236183617826772727727f2"));
	//const std::string testMnemonic = generateMnemonic(firstTestVector);
	const Mnemonic myMnemonicObj(firstTestVector); // = Mnemonic::generate(firstTestVector);
	const std::string testMnemonic = myMnemonicObj.toStr();
	
	
	std::cout << "The test mnemonic: " << testMnemonic << std::endl;
		
	const Mnemonic mnemonicObj2(testMnemonic);	
	const BigInt<256> secondTestVector = mnemonicObj2.toPrivKey();
		
	if(firstTestVector != secondTestVector)
	{	
		std::cout << "First test vector : " << firstTestVector << std::endl;
		std::cout << "Second test vector: " << secondTestVector << std::endl;
		
		throw std::string("Mnemonic test 1 failed");
	}
}


