#!/usr/bin/python

import os
import sys
import os.path

def printHeader(str) :
   "Prints header text"
   print("===================== " + str + " =====================")
   return

if not os.path.isfile("../bitgen-ppc"):
	print("Error, application binary does not exist")
	sys.exit()




#============ Start of tests ============

printHeader("Test 1 bitgen-ppc info")
retval1 = os.system("../bitgen-ppc info U8kkZrsN3f9cCujnsuJ5jLTh245B5tns1XRUESiaAqxrZULhG9zw")
if retval1 != 0:
	print("test 1 error")
	sys.exit()

printHeader("Test 2 bitgen-ppc info err")
retval1 = os.system("../bitgen-ppc info U8kkZrsN3kkkkkkkkkkkkkkkkkkkkkkkkkRUESiaAqxrZULhG9zw")
if retval1 == 0:
	print("test 2 error")
	sys.exit()


printHeader("Test 3 bitgen-ppc info")
retval1 = os.system("../bitgen-ppc info PTgCW43WNHR5RGHdHy76FWqxuAi34chVz7")
if retval1 != 0:
	print("test 3 error")
	sys.exit()

printHeader("Test 4 bitgen-ppc info err")
retval1 = os.system("../bitgen-ppc info PTgCW43Wwwwwwwwwwwwwwwwwwww34chVz7")
if retval1 == 0:
	print("test 4 error")
	sys.exit()



printHeader("Test 5 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc hash kdfdksjdhfjksdhfjhdsjfhjdhfjhkfjsdjjjdjjdjdjdjjdsjfdkfjhsdkfjhsdfkjhsdkfjhsdkjfhskjdhfsadjhasdkhaskdjhaksjdhkjhjhhhhfhfhjdjjjdjjdjdjjdsadjalskdjaslkjdalksjdlaksjdlkasjdlaksjdlkasjdlkasjdlaksjdlkasjdasdasda nops nocounter")
if retval1 != 0:
	print("test 5 error")
	sys.exit()


if not os.path.isfile("ppc_address_PVfSdJt8_private.txt"):
	print("test 5 file error")
	sys.exit()



printHeader("Test 6 bitgen-ppc hdice")
retval1 = os.system("../bitgen-ppc single dice 6126361236126312635353526351263512635162536125361253612536125312312312312312312312312312312321332131 nops nocounter")
if retval1 != 0:
	print("test 6 error")
	sys.exit()


if not os.path.isfile("ppc_address_PTS2qMnj_private.txt"):
	print("test 6 file error")
	sys.exit()



printHeader("Test 7 bitgen-ppc hex")
retval1 = os.system("../bitgen-ppc hex 116161678ABCDEFEFA1231231236127327633764736473643434342343423444 nops nocounter")
if retval1 != 0:
	print("test 7 error")
	sys.exit()


if not os.path.isfile("ppc_address_PKEzqS9i_private.txt"):
	print("test 7 file error")
	sys.exit()



printHeader("Test 8 bitgen-ppc hex compressed")
retval1 = os.system("../bitgen-ppc hex 116161678ABCDEFEFA1231231236127327633764736473643434342343423417 compressed nops nocounter")
if retval1 != 0:
	print("test 8 error")
	sys.exit()


if not os.path.isfile("ppc_address_PQYEFty2_private.txt"):
	print("test 8 file error")
	sys.exit()


#printHeader("Test 9 bitgen-ppc mnemonic")
#retval1 = os.system("../bitgen-ppc mnemonic \"nice upset area coconut emerge swim tomorrow hospital luggage mushroom abuse odor color early bicycle slow cart lamp gas lawn lava cancel insane amused\" nops nocounter")
#if retval1 != 0:
#	print("test 9 error")
#	sys.exit()
#
#if not os.path.isfile("ppc_address_PD8oPZxU_private.txt"):
#	print("test 9 file error")
#	sys.exit()


printHeader("Test 10 bitgen-ppc wif")
retval1 = os.system("../bitgen-ppc wif UDUoW47FCbqVaz4vRCaYL5zGPC37v8VBJTKDxbsPp4pNbZ7f8Nua nops nocounter")
if retval1 != 0:
	print("test 10 error")
	sys.exit()


if not os.path.isfile("ppc_address_PLbWb33D_private.txt"):
	print("test 10 file error")
	sys.exit()


printHeader("Test 11 bitgen-ppc mnemonic")
retval1 = os.system("../bitgen-ppc brainwallet mysalt@test.com \"This is the rather long passphrase that is used tO tEst thiS thing so we know that iit is workingg CorrectlY\" nops nocounter")
if retval1 != 0:
	print("test 11 error")
	sys.exit()


if not os.path.isfile("ppc_address_PJXu9c7W_private.txt"):
	print("test 11 file error")
	sys.exit()


printHeader("Test 12 bitgen-ppc brainwallet")
retval1 = os.system("../bitgen-ppc brainwallet thesalt \"This is my pass pass passs phrase stuff to make the address\" amount 12345 price 54321 nocounter")
if retval1 != 0:
	print("test 12 error")
	sys.exit()

if not os.path.isfile("ppc_address_PJ56SAgc_share.txt"):
	print("test 12 file error")
	sys.exit()

with open("ppc_address_PJ56SAgc_share.txt") as f:
	content1 = f.read()  
	if "12345.0" not in content1: 
		print("ppc test 12 file error brainwallet")
		sys.exit()

	if "54321.0" not in content1: 
		print("ppc test 12 file error brainwallet")
		sys.exit()



printHeader("Test 13 bitgen-ppc dice")
retval1 = os.system("../bitgen-ppc dice 2131231231231231231231231231231231231232312314441231231231231661123123123123123123123123213123212312 nocounter price 141414")
if retval1 != 0:
	print("test 13 error")
	sys.exit()

with open("ppc_address_PEAECwh2_private.txt") as f:
	content1 = f.read()  
	if "141414.0" not in content1: 
		print("ppc test 13 file error brainwallet")
		sys.exit()

	if "dice" not in content1: 
		print("ppc test 13 file error brainwallet")
		sys.exit()


printHeader("Test 14 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc hash sdfsdfsdfsdfkfkfkfksdkfksdkfskdfksdfsdfsdfsdfsdfsdfsdfsdfsdfsdfsdfsdfswdfsdfsdfsdfsdffffffffffffjfjfjjjjjjjjjjjjjjjjjjjjjjjjjjJJJJJJJJJJJKjdsffffffffffffffffffffffffffffffffffffffffffffffffffffsdfsdfsdfsdfsdfsdfsdf nocounter name MyName nops")
if retval1 != 0:
	print("test 14 error")
	sys.exit()

with open("ppc_address_PU9YNeHv_share.txt") as f:
	content1 = f.read()  
	if "MyName" not in content1: 
		print("ppc test 14 file error brainwallet")
		sys.exit()

	if "PU9YNeHvzY7pHB6MkgRvryeUcb6oXQVEcN" not in content1: 
		print("ppc test 14 file error brainwallet")
		sys.exit()



printHeader("Test 15 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc hex 123123123ABCDEF1231231231231231231231231231231231231231223123999 nocounter name MyName amount 998877")
if retval1 != 0:
	print("test 15 error")
	sys.exit()

with open("ppc_address_PLp2KhXd_private.txt") as f:
	content1 = f.read()  
	if "MyName" not in content1: 
		print("ppc test 15 file error brainwallet")
		sys.exit()

	if "U5ikfrA5Q3B5Jpbt3G1mjo51PfnkHnYuQFsyjxm2PVo2oNVmkH2D" not in content1: 
		print("ppc test 15 file error brainwallet")
		sys.exit()


printHeader("Test 16 bitgen-ppc random")
retval1 = os.system("../bitgen-ppc random nocounter name MyName amount 998877")
if retval1 != 0:
	print("test 16 error")
	sys.exit()




printHeader("Test 17 bitgen-ppc wif")
retval1 = os.system("../bitgen-ppc wif U6dPSf8nammzyZk4bUZh7VGfYS9hPhHG7GWxt3VTBLeDZvG4yfev nops nocounter")
if retval1 != 0:
	print("test 17 error")
	sys.exit()

with open("ppc_address_PE8kostn_share.txt") as f:
	content1 = f.read()  
	if "PE8kostn1zwJyHL69fY9PSWwTbcvtvvbdT" not in content1: 
		print("ppc test 17 file error brainwallet")
		sys.exit()

	if "Peercoin" not in content1: 
		print("ppc test 17 file error brainwallet")
		sys.exit()




printHeader("Test 18 bitgen-ppc brainwallet")
retval1 = os.system("../bitgen-ppc single brainwallet mysalt@test.com \"Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff Stuff \" nops nocounter")
if retval1 != 0:
	print("test 11 error")
	sys.exit()


if not os.path.isfile("ppc_address_PP7C39Re_share.txt"):
	print("test 11 file error")
	sys.exit()



printHeader("Test 19 bitgen-ppc brainwallet")
retval1 = os.system("../bitgen-ppc single brainwallet thesalt \"This is my pass pass passs phrase stuff to make the address\" amount 12345 price 54321 nocounter")
if retval1 != 0:
	print("test 19 error")
	sys.exit()

if not os.path.isfile("ppc_address_PJ56SAgc_share.txt"):
	print("test 19 file error")
	sys.exit()

with open("ppc_address_PJ56SAgc_share.txt") as f:
	content1 = f.read()  
	if "12345.0" not in content1: 
		print("ppc test 19 file error brainwallet")
		sys.exit()

	if "54321.0" not in content1: 
		print("ppc test 19 file error brainwallet")
		sys.exit()


printHeader("Test 20 bitgen-ppc dice")
retval1 = os.system("../bitgen-ppc single dice 2134444231231231231231231231231231231232312314441231231231231661123123123123123123123123213123212312 nocounter price 141414")
if retval1 != 0:
	print("test 20 error")
	sys.exit()

with open("ppc_address_PFUb7Qve_share.txt") as f:
	content1 = f.read()  
	if "141414.0" not in content1: 
		print("ppc test 13 file error brainwallet")
		sys.exit()

	if "PFUb7QveHbMoSqh2ggYfC9CS6QYZB8mgMF" not in content1: 
		print("ppc test 13 file error brainwallet")
		sys.exit()



printHeader("Test 21 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc single hash sdfsdfsdfsdGRTkfkfksdkfksdkfskdfksdfsdfsdfsdfsdfsdfsdfsdfsdfsdfsdfsdfswdfsdfsdfsdfsdffffffffffffjfjfjjjjjjjjjjjjjjjjjjjjjjjjjjJJJJJJJJJJJKjdsffffffffffffffffffffffffffffffffffffffffffffffffffffsdfsdfsdfsdfsdfsdfsdf nocounter name TheName nops")
if retval1 != 0:
	print("test 21 error")
	sys.exit()

with open("ppc_address_PBWMTy6G_private.txt") as f:
	content1 = f.read()  
	if "TheName" not in content1: 
		print("ppc test 21 file error brainwallet")
		sys.exit()

	if "PBWMTy6GaTjwjLb4WrLizpvLJ4V2GBHoNg" not in content1: 
		print("ppc test 21 file error brainwallet")
		sys.exit()



printHeader("Test 22 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc single hex 123123666ABCDEF1231231231231231231231231231231231231231223123999 nocounter name MyName amount 998877")
if retval1 != 0:
	print("test 22 error")
	sys.exit()

with open("ppc_address_PHab75Ay_share.txt") as f:
	content1 = f.read()  
	if "MyName" not in content1: 
		print("ppc test 22 file error brainwallet")
		sys.exit()

	if "PHab75AyfRWgrHHWiyL6Z9xNZVkdxxq5wz" not in content1: 
		print("ppc test 22 file error brainwallet")
		sys.exit()




printHeader("Test 23 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc single wif U6dPSf8nammzyZk4bUZh7VGfYS9hPhHG7GWxt3VTBLeDZvG4yfev nops nocounter")
if retval1 != 0:
	print("test 23 error")
	sys.exit()

with open("ppc_address_PE8kostn_share.txt") as f:
	content1 = f.read()  
	if "PE8kostn1zwJyHL69fY9PSWwTbcvtvvbdT" not in content1: 
		print("ppc test 23 file error brainwallet")
		sys.exit()

	if "Peercoin" not in content1: 
		print("ppc test 23 file error brainwallet")
		sys.exit()



printHeader("Test 24 bitgen-ppc hash")
retval1 = os.system("../bitgen-ppc binary hex 2342342342342342342342342342342342342342342342342342342349238492")
if retval1 != 0:
	print("test 24 error")
	sys.exit()





print("")
print("")
print("")
print("Cleaning up")
os.system("rm *.trans *.script *.txt *.sig")

print("")
print("")
print("")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++ All tests passed OK +++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")


sys.exit(123)
