#!/usr/bin/python

import os
import sys
import os.path

def printHeader(str) :
   "Prints header text"
   print("===================== " + str + " =====================")
   return

if not os.path.isfile("../bitgen-bch"):
	print("Error, application binary does not exist")
	sys.exit()




#============ Start of tests ============

retval0 = os.system("../bitgen-bch setnextnum 36")
if retval0 != 0:
	print("test init error")
	sys.exit()



printHeader("Test 1 bitgen-bch hex")
retval1 = os.system("../bitgen-bch hex 8723647823647823647826378462374627364723784623784623ABC422342342")
if retval1 != 0:
	print("test 11 error")
	sys.exit()

with open("bch_address_36_qrkh04wh_private.txt") as f:
	content1 = f.read()  
	if "L1kQGXVVrAUM26bFkCDj9aHseT34evXMroHug8JBmtUeCpNfxaiL" not in content1: 
		print("test 1 priv error")
		sys.exit()

	if "qrkh04whu3uzy039wuf3jh8zxvgzgehsgu260ea288" not in content1: 
		print("test 1 pub error")
		sys.exit()

#========================


printHeader("Test 2 bitgen-bch hex")
retval1 = os.system("../bitgen-bch single dice 1253126536125361536512635126351231231231231231231231231231231231231231231232363636631231231231236363")
if retval1 != 0:
	print("test 11 error")
	sys.exit()

with open("bch_address_37_qpy8d26q_private.txt") as f:
	content1 = f.read()  
	if "KyY9ZbGMFehwkZJaFj2uocuaWDfPuWqHjyV6eNSEfw5A6njKQjhP" not in content1: 
		print("test 1 priv error")
		sys.exit()

	if "qpy8d26qwm2njec8a4t974fg6rftjchgkq0nxlkvw0" not in content1: 
		print("test 1 pub error")
		sys.exit()




#========================


printHeader("Test 3 bitgen-bch hex")
retval1 = os.system("../bitgen-bch hash kjsdhfksjhfjksdhfjksdhfjksdhfjksfjkhjksdhsjfhssdjkfhsdjkfsdjkhfsjkdhfsdfuyuisdfuissdiofusfsdUIASDUFIUJKHKHKJhdfsjhfjshdfjshdjfhsjhfhJHjHjHjHjHjhjhJKHjksdfhjkshdfsdfsfsdfslkdfjslkdjfskldjfklsdfjklsdjfuiusdufsdifusiouuweuioeurio")
if retval1 != 0:
	print("test 3 error")
	sys.exit()

with open("bch_address_38_qzykqm8p_private.txt") as f:
	content1 = f.read()  
	if "KwU8grurmpPwizDrizmgMuTBEHQxDjwoWyhcUhjK8HPkAUqDEiDK" not in content1: 
		print("test 1 priv error")
		sys.exit()

	if "qzykqm8prm78thc5d3ygfnhmpfu0ql00fgt50xkrq8" not in content1: 
		print("test 1 pub error")
		sys.exit()



#========================


printHeader("Test 4 bitgen-bch hex")
retval1 = os.system("../bitgen-bch wif L4sDigCzPjFjwwZSZnYaxEqAPMCzeajiNEVZJiiExRtTubx6yzZN")
if retval1 != 0:
	print("test 4 error")
	sys.exit()

with open("bch_address_39_qp5hnzq8_private.txt") as f:
	content1 = f.read()  
	if "L4sDigCzPjFjwwZSZnYaxEqAPMCzeajiNEVZJiiExRtTubx6yzZN" not in content1: 
		print("test 1 priv error")
		sys.exit()

	if "qp5hnzq8hjvf3psxjqy2engfx42t9t79uqq804gyeq" not in content1: 
		print("test 1 pub error")
		sys.exit()

#========================


printHeader("Test 5 bitgen-bch hex")
retval1 = os.system("../bitgen-bch brainwallet my@salt.com \"fhhfhf djfhsdjfh ksjdfh ksdjfhskdjf hsdkjfh skdjfh sdkfjh sdfjkshdfksjdfh sjkdfh\"")
if retval1 != 0:
	print("test 4 error")
	sys.exit()

with open("bch_address_40_qqyaah5l_private.txt") as f:
	content1 = f.read()  
	if "KxcQgGrCpKazDskxSDKkMMGpGQ6sRdjmTs54tEn5RLfZrJ1WyEXe" not in content1: 
		print("test 1 priv error")
		sys.exit()

	if "qqyaah5lxeekdnmjfsr4nj4uctc4n5gnxqp32hplu7" not in content1: 
		print("test 1 pub error")
		sys.exit()



print("")
print("")
print("")
print("Cleaning up")
os.system("rm *.trans *.script *.txt *.sig")

print("")
print("")
print("")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++ All tests passed OK +++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")


sys.exit(123)
