#!/usr/bin/python

import os
import sys
import os.path

def printHeader(str) :
   "Prints header text"
   print("===================== " + str + " =====================")
   return

if not os.path.isfile("../bitgen-bch"):
	print("Error, application binary does not exist")
	sys.exit()

retvalRemovexor = os.system("../bitgen-bch removexor")
#print("retvalRemovexor: " + str(retvalRemovexor)
if retvalRemovexor == 0:
	print("Error, test can not be performed with static xor configured")
	sys.exit()

#============ Start of tests ============

retval1 = os.system("../bitgen-bch setnextnum 36")
if retval1 != 0:
	print("test init error")
	sys.exit()


printHeader("Test 1 bitgen-bch pub 1")
retval1 = os.system("../bitgen pub qqzaw9sagp8thykp5j6l6nkhy7gjn09gh5u3vlqpwk")
if retval1 != 0:
	print("test 1 error")
	sys.exit()


if not os.path.isfile("pub_36_qqzaw9sa_share.ps"):
	print("test 1 file error")
	sys.exit()

with open("pub_36_qqzaw9sa_share.ps") as f:
	content1 = f.read()  
	if "qqzaw9sagp8thykp5j6l6nkhy7gjn09gh5u3vlqpwk" not in content1: 
		print("test 1 file error for pad 1")
		sys.exit()




printHeader("Test 1 bitgen-bch pub 2")
retval1 = os.system("../bitgen pub")
if retval1 != 0:
	print("test 2 error")
	sys.exit()



printHeader("Test 3 bitgen-bch pub 3")
retval1 = os.system("../bitgen pub qrhyq402d4lv38085wcmxpnruf2pcd8zjv26pndr6x name MyLabel")
if retval1 != 0:
	print("test 3 error")
	sys.exit()


if not os.path.isfile("pub_37_qrhyq402_share.ps"):
	print("test 3 file error")
	sys.exit()

with open("pub_37_qrhyq402_share.ps") as f:
	content1 = f.read()  
	if "qrhyq402d4lv38085wcmxpnruf2pcd8zjv26pndr6x" not in content1: 
		print("test 3 file error for contant")
		sys.exit()





printHeader("Test 4 bitgen-bch invoice")
retval1 = os.system("../bitgen invoice qzcuxkl2hkulfrzcwaed7cszzdlher27sywecvpgqm amount 1.5 name thelabel message themessage time thedate")
if retval1 != 0:
	print("test 4 error")
	sys.exit()


if not os.path.isfile("num_38_qzcuxkl2_invoice.ps"):
	print("test 4 file error")
	sys.exit()

with open("num_38_qzcuxkl2_invoice.ps") as f:
	content1 = f.read()  
	if "qzcuxkl2hkulfrzcwaed7cszzdlher27sywecvpgqm" not in content1: 
		print("test 4 file error for contant")
		sys.exit()

	if "thelabel" not in content1: 
		print("test 4 file error for content")
		sys.exit()


	if "themessage" not in content1: 
		print("test 4 file error for content")
		sys.exit()

	if "thedate" not in content1: 
		print("test 4 file error for content")
		sys.exit()









printHeader("Test 6 bitgen-bch brainwallet")
retval1 = os.system("../bitgen single brainwallet pepper your_little_passphrase_stuff_that_will_be_used_for_this_thing name MYNAME amount 12.34")
if retval1 != 0:
	print("test 6 error")
	sys.exit()


if not os.path.isfile("bch_address_39_qr3rv7nj_private.txt"):
	print("test 6 file error")
	sys.exit()

with open("bch_address_39_qr3rv7nj_private.txt") as f:
	content1 = f.read()  
	if "qr3rv7njfn3x347zyf4utynxrrlpp4dkvynzsawhmt" not in content1: 
		print("test 6 file error for contant")
		sys.exit()

	if "KxqFsCZ3CiCuENbLrmgYyv9QN98GcUWQnXxP651ZRX5PEtyVMTFP" not in content1: 
		print("test 6 file error for content")
		sys.exit()

	if "MYNAME" not in content1:
		print("test 6 file error for content")
		sys.exit()

	if "12.34" not in content1: 
		print("test 6 file error for content")
		sys.exit()




printHeader("Test 7 bitgen-bch brainwallet")
retval1 = os.system("../bitgen single brainwallet pepper our_little_passphrase_stuff_that_will_be_used_for_this_thing name SOMENAME amount 12.34 price 4444 time MyTime nops")
if retval1 != 0:
	print("test 7 error")
	sys.exit()


if not os.path.isfile("bch_address_40_qrpdgdr8_private.txt"):
	print("test 7 file error")
	sys.exit()

with open("bch_address_40_qrpdgdr8_private.txt") as f:
	content1 = f.read()  
	if "qrpdgdr8r7dhdgwp2a7yf4w4h6raqrm9yvh35wplct" not in content1: 
		print("test 7 file error for address content")
		sys.exit()

	if "Kz8BbrDFmNwnz8xc1TwDvSxCDM5pgeB6ZnaeCz7eisWGJsn3egSG" not in content1: 
		print("test 7 file error for priv content")
		sys.exit()

	if "SOMENAME" not in content1:
		print("test 7 file error for name content")
		sys.exit()

	if "12.34" not in content1: 
		print("test 7 file error for amount content")
		sys.exit()

	if "4444.0" not in content1: 
		print("test 7 file error for price content")
		sys.exit()




printHeader("Test 8 bitgen-bch dice")
retval1 = os.system("../bitgen single dice 1232635162536125362562565625652526555252651653612536125361253615263512635126351263561253123123123123 name accountname amount 4.3 price 4.5 nops")
if retval1 != 0:
	print("test 7 error")
	sys.exit()


if not os.path.isfile("bch_address_41_qp7kev3v_private.txt"):
	print("test 7 file error")
	sys.exit()

with open("bch_address_41_qp7kev3v_private.txt") as f:
	content1 = f.read()  
	if "qp7kev3v4t38lyyvfyc8v9p2tzyhspjcxv5mdujx2d" not in content1: 
		print("test 7 file error for address content")
		sys.exit()

	if "Ky5qLHZFx4CDF5uuaAFL3LLJED1HaEobkHntD6gPbAGMBzgkG86E" not in content1: 
		print("test 7 file error for priv content")
		sys.exit()

	if "accountname" not in content1:
		print("test 7 file error for name content")
		sys.exit()

	if "4.3" not in content1: 
		print("test 7 file error for amount content")
		sys.exit()

	if "4.5" not in content1: 
		print("test 7 file error for price content")
		sys.exit()




printHeader("Test 9 bitgen-bch hash")
retval1 = os.system("../bitgen single hash Theahashvalsdklfsdlfjskljfklsdjfklsjdfklsjdfklsdjfklsdjfklsjdfkljsdklfjsdklfjsdkljjsdfjskldjfskldjfklsdjfsdklfjsdfsdfsdfsdfsdfsdfsdfjskdjfksdjfksdjfksjdfjsdkfjsdkjfsdkjfksduuudsfiusdifusdfsdfsdfsdfsdjklfsdkfjslkdfjsdklfj price 111 time MyDateAndTime nops")
if retval1 != 0:
	print("test 9 error")
	sys.exit()


if not os.path.isfile("bch_address_42_qra73dzu_share.txt"):
	print("test 7 file error")
	sys.exit()

with open("bch_address_42_qra73dzu_share.txt") as f:
	content1 = f.read()  
	if "qra73dzuqvq8yefkwd0juetkunppj5y4wyhu76q0ks" not in content1: 
		print("test 7 file error for address content")
		sys.exit()

	if "MyDateAndTime" not in content1: 
		print("test 7 file error for date content")
		sys.exit()

	if "111.0" not in content1:
		print("test 7 file error for name content")
		sys.exit()





printHeader("Test 10 bitgen-bch hex")
retval1 = os.system("../bitgen single hex 12312312736127361782631278FFAFAFAFDDDCCBBCBBCBCBBAAAAAAAAAAADDDE nocounter")
if retval1 != 0:
	print("test 10 error")
	sys.exit()

if not os.path.isfile("bch_address_qzvj7ds3_private.txt"):
	print("test 7 file error")
	sys.exit()

with open("bch_address_qzvj7ds3_private.txt") as f:
	content1 = f.read()  
	if "qzvj7ds3788wzx60anuxdmsaaku4y9584sq26vslzg" not in content1: 
		print("test 7 file error for address content")
		sys.exit()

	if "Kwq5DyLtbVp3d7Kt7pepJj41BBp3Cm2hqhnp2PkuFyR3wbVW1XyA" not in content1: 
		print("test 7 file error for date content")
		sys.exit()

	if "12312312736127361782631278FFAFAFAFDDDCCBBCBBCBCBBAAAAAAAAAAADDDE" not in content1:
		print("test 7 file error for name content")
		sys.exit()





printHeader("Test 11 bitgen-bch binary")
retval1 = os.system("../bitgen binary hex 1231231231231231231231231723127309712903129038102938901283901283")
if retval1 != 0:
	print("test 11 error")
	sys.exit()





printHeader("Test 12 bitgen-bch wif")
retval1 = os.system("../bitgen wif L13kNhj2gZfCLut8v5Kb4q4FxgWqJrtRopcb8Ri3bWoiLxKw3Law amount 3.33 price 1.11 name TheName nocounter")
if retval1 != 0:
	print("test 12 error")
	sys.exit()

if not os.path.isfile("bch_address_qpkukqjd_share.txt"):
	print("test 12 file error")
	sys.exit()

with open("bch_address_qpkukqjd_share.txt") as f:
	content1 = f.read()  
	if "qpkukqjd6n0lcfe4vu6yyv2wlvh26lkkxvhwa2jvq3" not in content1: 
		print("test 12 file error for address content")
		sys.exit()

	if "3.33" not in content1: 
		print("test 12 file error for date content")
		sys.exit()

	if "1.11" not in content1:
		print("test 12 file error for name content")
		sys.exit()



printHeader("Test 13 bitgen-bch addname")
retval1 = os.system("../bitgen addname MyName")
if retval1 != 0:
	print("test 13 error")
	sys.exit()


printHeader("Test 14 bitgen-bch removename")
retval1 = os.system("../bitgen removename")
if retval1 != 0:
	print("test 14 error")
	sys.exit()



printHeader("Test 15 bitgen-bch electrum")
retval1 = os.system("../bitgen electrum hash sdfsdfhsdkjfhsdjkfhsjkdhfjksdhfjkshdfjkshdfhHHHHjksdhfjkshdfjkhsdfjkhsdkjfhsjdhfjhjhHHhhhjdkfhgdfgdfgdfgdfgdfgdfghsdfhsdhfjksdhfkjshdfkshdfjshdfhsdhfshdfhdhfhsdjfhsdfyyyyfyfyyfysduifysidufysuidfysuidyf name TheName nocounter")
if retval1 != 0:
	print("test 15 error")
	sys.exit()

if not os.path.isfile("electrum_bch_qsAEMXYz_private.txt"):
	print("test 12 file error")
	sys.exit()

with open("electrum_bch_qsAEMXYz_private.txt") as f:
	content1 = f.read()  
	if "xpub661MyMwAqRbcFVqbVQXKzufjemv79PQoTBjmS5exSZUSDYqsAEMXYzsrsdTGZzBLhEoxV5uXNpJaiAkLQNNMAfvtTibhKTZ8XJoeMgMnDNz" not in content1: 
		print("test 12 file error for address content")
		sys.exit()

	if "xprv9s21ZrQH143K31m8PNzKdmj16k5cjvgx5xpAdhFLtDwTLkWich3H1CZP2MXopu7xe9E4QwTgbwDDkj311GiH6W8soXPf78TcpLU9cQHkNSJ" not in content1: 
		print("test 12 file error for date content")
		sys.exit()

	if "TheName" not in content1:
		print("test 12 file error for name content")
		sys.exit()





printHeader("Test 16 bitgen-bch electrum dice")
retval1 = os.system("../bitgen electrum dice 12312312312312366123412312312313234234234111414432 words 12")
if retval1 != 0:
	print("test 16 error")
	sys.exit()

if not os.path.isfile("electrum_bch_43_FZd7UZAs_share.txt"):
	print("test 12 file error")
	sys.exit()

with open("electrum_bch_43_FZd7UZAs_share.txt") as f:
	content1 = f.read()  
	if "xpub661MyMwAqRbcFfVtZt6RTdRpeDPWVpbEDiBMWSAr4JkK8yFZd7UZAsYMtEdyVYmeoMUg7jKi81g1Fdj1dUBBeifMADonPWHZnqTAJ6PVRRM" not in content1: 
		print("test 12 file error for address content")
		sys.exit()

	if "bch address 43" not in content1: 
		print("test 12 file error for date content")
		sys.exit()

	if "m0S" not in content1:
		print("test 12 file error for name content")
		sys.exit()




printHeader("Test 17 bitgen-bch electrum hex")
retval1 = os.system("../bitgen electrum hex 2A4234098098ABCDEF12873618273618723678126 words 15 name Aname nocounter")
if retval1 != 0:
	print("test 17 error")
	sys.exit()

if not os.path.isfile("electrum_bch_T4z5AYTw_private.txt"):
	print("test 17 file error")
	sys.exit()

with open("electrum_bch_T4z5AYTw_private.txt") as f:
	content1 = f.read()  
	if "xpub661MyMwAqRbcFLHCfDCVaGEPDY1YjeyNR5LYfthMeB8gprT4z5AYTwewr4Gii5vfXkEk4QkHUyG8QFdSv7gozhAPNb4hErpX5dUL5oT4KVF" not in content1: 
		print("test 17 file error for address content")
		sys.exit()

	if "xprv9s21ZrQH143K2rCjZBfVD8HefWB4LCFX3rQwsWHk5qbhx47vSXrHv9LTzpM2etLAKRMUbYURDFsXEyvdSwjEaeuuQWkrMa41FdLPTnYrCkb" not in content1: 
		print("test 17 file error for date content")
		sys.exit()

	if "2A4234098098ABCDEF12873618273618723678126" not in content1:
		print("test 17 file error for name content")
		sys.exit()




printHeader("Test 18 bitgen-bch electrum brain")
retval1 = os.system("../bitgen electrum brain myemailsalt ThisIsTheBrainValThatIsUsedToGetTheSecretElemtrumSeedForThisLittleSmallBigHugeVeryVeryVeryVeryHugeThing nocounter")
if retval1 != 0:
	print("test 18 error")
	sys.exit()

if not os.path.isfile("electrum_bch_XcDxKKpX_private.txt"):
	print("test 18 file error")
	sys.exit()

with open("electrum_bch_XcDxKKpX_private.txt") as f:
	content1 = f.read()  
	if "xpub661MyMwAqRbcFgZiGqLF1J5k2qQAkCttxTfgfvjEVjCVP4XcDxKKpXJWjvJ6QYRvTejeu2Vs3efkWKMyfdEMzcKdgm46htB9jbBwMketkva" not in content1: 
		print("test 18 file error for address content")
		sys.exit()

	if "xprv9s21ZrQH143K3CVFAooEeA91UoZgLkB3bEk5sYKcwPfWWGCTgR15Giz2tfysxiNBXSbRazG5FA9c2oMMuFPRDWkFyDuKJKWnufMvrhnzfAc" not in content1: 
		print("test 18 file error for date content")
		sys.exit()

	if "ThisIsTheBrainValThatIsUsedToGetTheSecretElemtrumSeedForThisLittleSmallBigHugeVeryVeryVeryVeryHugeThing" not in content1:
		print("test 18 file error for name content")
		sys.exit()


printHeader("Test 19 bitgen-bch info")
retval1 = os.system("../bitgen info L2JPaWU9ryzUf7ZHFvN74nx7cQGmzDVkuyjnPgQaxhbAjvQ9Wocn")
if retval1 != 0:
	print("test 19 error")
	sys.exit()



printHeader("Test 20 bitgen-bch setlang")
retval1 = os.system("../bitgen setlang en")
if retval1 != 0:
	print("test 20 error")
	sys.exit()




#printHeader("Test 21 bitgen-bch otpdir")
#retval1 = os.system("../bitgen otpdir")
#if retval1 != 0:
#	print("test 21 error")
#	sys.exit()



printHeader("Test 22 bitgen-bch otpdir")
retval1 = os.system("../bitgen derivation xprv9s21ZrQH143K3BzgUSoTREsv5VuATRPR6jcu6LH1bgoMYmUyhqazvK4JbeqistAEMnAdhZDbKwMmKGAJhAVz2gNT9fEqwDEaJoxAAx8nPAh \"m/44H/145H/0H\"")
if retval1 != 0:
	print("test 22 error")
	sys.exit()



retval1 = os.system("../bitgen addressderivation xprv9s21ZrQH143K3BzgUSoTREsv5VuATRPR6jcu6LH1bgoMYmUyhqazvK4JbeqistAEMnAdhZDbKwMmKGAJhAVz2gNT9fEqwDEaJoxAAx8nPAh \"m/44H/145H/0H/0\" 1")
if retval1 != 0:
	print("test 23 error")
	sys.exit()



if not os.path.isfile("derddr_bch_0_1_1093BFFD934FFC21AAFD_R7wGZmjn6mq7nNwhPytKjSwmdtNdjfXRzJahpgonBWhpByPiiXq_private.txt"):
	print("test 13 file error")
	sys.exit()


with open("derddr_bch_0_1_1093BFFD934FFC21AAFD_R7wGZmjn6mq7nNwhPytKjSwmdtNdjfXRzJahpgonBWhpByPiiXq_private.txt") as f:
	content1 = f.read()  
	if "L5SjStJQEWDbJC3fKtxC1R9Zt3Gi2gD92rTdQHZ3WpseoJqhJcAB" not in content1: 
		print("test 18 file error for address content")
		sys.exit()

	if "qrn6rtul8kx693wzk5j97hrwawayph30av5afscg7a" not in content1: 
		print("test 18 file error for address content")
		sys.exit()

	if "L3kUoDbMAzuaX3mo62WYMgyDfHtCaREqZ5JLxx68UGJTCzodANUu" not in content1: 
		print("test 18 file error for address content")
		sys.exit()

	if "qqza96pdzd4eem36mf4j8dcgglf4ux7faqhkwze59y" not in content1: 
		print("test 18 file error for address content")
		sys.exit()




retval1 = os.system("../bitgen addressderivation xprv9s21ZrQH143K3Gbf26DWvMSxBP3PkHm36uk9V99hfPqYBSUqBuTdjuvE8vJdXw4VdKUQUEYg4igTVvrLuBEUXpb8UnUCFeuWQ2rxFJeeAaK receive 10")
if retval1 != 0:
	print("test 23 error")
	sys.exit()

if not os.path.isfile("derddr_bch_0_10_A224797D113C3C25E5CD_4rZF4k6i4K7ze9pDzkuaQLpBf1C4g9mmy8HGAbnTNAKEPTsP8Um_private.txt"):
	print("test 23 file error")
	sys.exit()

with open("derddr_bch_0_10_A224797D113C3C25E5CD_4rZF4k6i4K7ze9pDzkuaQLpBf1C4g9mmy8HGAbnTNAKEPTsP8Um_private.txt") as f:
	content1 = f.read()  
	if "KwhBGHbUr3E3HDXqKPWJzaKxwFpqEc7h1dGKqmqEk8Pq6UUzMKkb" not in content1: 
		print("test 23 file error for address content")
		sys.exit()

	if "KyNzemZrsUyv6JBVJEPoCX9meYp7rw77iTxmDbjVFyyUv6FqZAGy" not in content1: 
		print("test 23 file error for address content")
		sys.exit()

	if "L5MhFRSZ8Gwq7YkJ4biHoMLwSo1ZrNf6HqeEgt61jHfbSpzQeJBX" not in content1: 
		print("test 23 file error for address content")
		sys.exit()

	if "KySPLiXPzfPVvEsfKk7ze8bUqqZy9QDqzpDkr2K2qHQvp9h1UZ8T" not in content1: 
		print("test 23 file error for address content")
		sys.exit()


print("")
print("")
print("")
print("Cleaning up")
os.system("rm *.txt *.ps")

print("")
print("")
print("")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++ All tests passed OK +++++++++++++++++++++++++++")
print("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")


sys.exit(123)
